<template>
	<div class="app-container">
		<el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
			<el-form-item label="员工名称" prop="userName">
				<el-input
					v-model="queryParams.userName"
					placeholder="请输入员工名称"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>
			<el-form-item label="联系方式" prop="phonenumber">
				<el-input
					v-model="queryParams.phonenumber"
					placeholder="请输入联系方式"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>
			<el-form-item>
				<el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
				<el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
			</el-form-item>
		</el-form>

		<el-row :gutter="10" class="mb8">
			<el-col :span="1.5">
				<el-button
					type="success"
					plain
					icon="el-icon-edit"
					size="mini"
					:disabled="multiple"
					@click="handleUpdate"
					v-hasPermi="['quality:material:edit']"
				>绑定</el-button>
			</el-col>
			<right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
		</el-row>
		<!-- 列表数据 -->
		<el-table v-loading="loading" :data="materialList" @selection-change="handleSelectionChange">
			<el-table-column type="selection" width="55" align="center" />
			<el-table-column label="员工编号" align="center" prop="userId" />
			<el-table-column label="姓名" align="center" prop="userName" />
			<el-table-column label="联系方式" align="center" prop="phonenumber" />
			<el-table-column label="邮箱" align="center" prop="email" />
			<el-table-column label="绑定的检验物料" align="center" prop="materialNames" width="400" />
			<el-table-column label="状态" align="center" prop="status" >
				<template slot-scope="scope">
					<span
						v-if="scope.row.status === '0'"
					>正常</span>
					<span
						v-if="scope.row.status === '1'"
					>停用</span>
				</template>
			</el-table-column>
			<el-table-column label="操作" align="center" class-name="small-padding fixed-width">
				<template slot-scope="scope">
					<el-button
						size="mini"
						type="text"
						icon="el-icon-edit"
						@click="handleUpdate(scope.row)"
						v-hasPermi="['quality:material:edit']"
					>绑定</el-button>
				</template>
			</el-table-column>
		</el-table>

		<pagination
			v-show="total>0"
			:total="total"
			:page.sync="queryParams.pageNum"
			:limit.sync="queryParams.pageSize"
			@pagination="getList"
		/>

		<!-- 添加或修改人员物料绑定对话框 -->
		<el-dialog :title="title" :visible.sync="open" width="960px" append-to-body>
			<el-form ref="form" :model="form" :rules="rules" label-width="80px">
				<el-form-item label="用户编码" prop="userCodes">
					<el-input v-model="form.userCodes" disabled placeholder="请输入用户编码" />
				</el-form-item>
			</el-form>
			<el-tabs type="border-card" v-if="form.userCodes != null">
				<el-tab-pane label="关联物料">
					<UserBind v-if="form.userCodes !=null" :optType="optType" :userCodes="form.userCodes"></UserBind>
				</el-tab-pane>
			</el-tabs>
			<div slot="footer" class="dialog-footer">
				<el-button type="primary" @click="submitForm">确 定</el-button>
				<el-button @click="cancel">取 消</el-button>
			</div>
		</el-dialog>
	</div>
</template>

<script>
import { listMaterial, getMaterial, delMaterial, addMaterial, updateMaterial } from "@/api/quality/material";
import UserBind from "./userbind.vue";

export default {
	name: "Material",
	components: {UserBind},
	data() {
		return {
			// 遮罩层
			loading: true,
			// 选中数组
			ids: [],
			// 非单个禁用
			single: true,
			// 非多个禁用
			multiple: true,
			// 显示搜索条件
			showSearch: true,
			// 总条数
			total: 0,
			// 人员物料绑定表格数据
			materialList: [],
			// 弹出层标题
			title: "",
			// 是否显示弹出层
			open: false,
			// 查询参数
			queryParams: {
				pageNum: 1,
				pageSize: 10,
				userCode: null,
				userName: null,
				userCodes: null,
				materialCode: null,
				materialName: null,
				materialNames: null,
				phonenumber: null,
				attr1: null,
				attr2: null,
				attr3: null,
				factoryCode: null,
			},
			// 表单参数
			form: {},
			// 表单校验
			rules: {
				factoryCode: [
					{ required: true, message: "工厂编码不能为空", trigger: "blur" }
				],
			}
		};
	},
	created() {
		this.getList();
	},
	methods: {
		/** 查询人员物料绑定列表 */
		getList() {
			this.loading = true;
			listMaterial(this.queryParams).then(response => {
				this.materialList = response.rows;
				this.total = response.total;
				this.loading = false;
			});
		},
		// 取消按钮
		cancel() {
			this.open = false;
			this.reset();
			this.getList();
		},
		// 表单重置
		reset() {
			this.form = {
				id: null,
				userCode: null,
				userName: null,
				userCodes: null,
				materialCode: null,
				materialName: null,
				materialNames: null,
				phonenumber: null,
				attr1: null,
				attr2: null,
				attr3: null,
				createBy: null,
				createTime: null,
				updateBy: null,
				updateTime: null,
				factoryCode: null,
				delFlag: null
			};
			this.resetForm("form");
		},
		/** 搜索按钮操作 */
		handleQuery() {
			this.queryParams.pageNum = 1;
			this.getList();
		},
		/** 重置按钮操作 */
		resetQuery() {
			this.resetForm("queryForm");
			this.handleQuery();
		},
		// 多选框选中数据
		handleSelectionChange(selection) {
			this.ids = selection.map(item => item.userCode)
			this.single = selection.length!==1
			this.multiple = !selection.length
		},
		/** 新增按钮操作 */
		handleAdd() {
			this.reset();
			this.open = true;
			this.title = "添加人员物料绑定";
		},
		/** 绑定按钮操作 */
		handleUpdate(row) {
			this.reset();
			const userCodes = row.userCode || this.ids
			this.form.userCodes = userCodes;
			this.open = true;
			this.title = "修改人员物料绑定";
			this.optType = "edit";
			// getMaterial(userCode).then(response => {

			// });
		},
		/** 提交按钮 */
		submitForm() {
			this.open = false;
			this.getList();
			/* this.$refs["form"].validate(valid => {
				if (valid) {
					if (this.form.id != null) {
						updateMaterial(this.form).then(response => {
							this.$modal.msgSuccess("修改成功");
							this.open = false;
							this.getList();
						});
					} else {
						addMaterial(this.form).then(response => {
							this.$modal.msgSuccess("新增成功");
							this.open = false;
							this.getList();
						});
					}
				}
			}); */
		},
		/** 删除按钮操作 */
		handleDelete(row) {
			const ids = row.userCode || this.ids;
			this.$modal.confirm('是否确认删除人员物料绑定编号为"' + ids + '"的数据项？').then(function() {
				return delMaterial(ids);
			}).then(() => {
				this.getList();
				this.$modal.msgSuccess("删除成功");
			}).catch(() => {});
		},
		/** 导出按钮操作 */
		handleExport() {
			this.download('quality/material/export', {
				...this.queryParams
			}, `material_${new Date().getTime()}.xlsx`)
		}
	}
};
</script>
